<template>
    <div class="container">
       <div class="row mt-5">
           <div class="col-md-12">
              <div class="card-header">
                <h3 class="card-title">Users table</h3>

                <div class="card-tools">
                  <button class="btn btn-success" data-toggle="modal" data-target="#addNew">Add new <i class="fas fa-plus fa-fw"></i></button>
                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive p-0">
                <table class="table table-hover">
                  <thead class="thead-dark">
                    <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>Email</th>
                      <th>Type</th>
                      <th>registared at</th>
                      <th>Modify</th>
                    </tr>
                  </thead>
                  <tbody>

                    <tr v-for="user in users" :key="user.id">
                      <td>{{user.id}}</td>
                      <td>{{user.name}}</td>
                      <td>{{user.email}}</td>
                      <td>{{user.type|capitalize}}</td>
                      <td>{{user.created_at|myDate}}</td>
                      <td>
                         <a href="#">
                             <i class="fa fa-edit yellow"></i>
                         </a>
                          <a href="#">
                             <i class="fa fa-trash red"></i>
                         </a>
                      </td>
                    </tr>
                    
                  
                  </tbody>
                </table>
              </div>
              <!-- /.card-body -->
            </div>
       </div>
     <!-- Modal -->
<div class="modal fade" id="addNew" tabindex="-1" role="dialog" aria-labelledby="addNewTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="addNewTitle">Add new</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form @submit.prevent="createUser">
      <div class="modal-body">
            <div class="form-group">
                <input  v-model="form.name" type="text" name="name" placeholder="name" class="form-control" :class="{'is-invalid':form.errors.has('name')}">
                <has-error :form="form" field="name"></has-error>
            </div>
            <div class="form-group">
                <input  v-model="form.email" type="email" name="email" placeholder="email" class="form-control" :class="{'is-invalid':form.errors.has('email')}">
                <has-error :form="form" field="email"></has-error>
            </div>
            <div class="form-group">
                <input  v-model="form.password" type="password" name="password" placeholder="password" class="form-control" :class="{'is-invalid':form.errors.has('password')}">
                <has-error :form="form" field="password"></has-error>
            </div>
            <div class="form-group">
                <textarea  v-model="form.bio"  name="bio" placeholder="a short description" class="form-control" :class="{'is-invalid':form.errors.has('bio')}"></textarea>
                <has-error :form="form" field="bio"></has-error>
            </div>

             <div class="form-group">
                <select  v-model="form.type" type="type" name="user" placeholder="type" class="form-control" :class="{'is-invalid':form.errors.has('type')}">
               <option value="">Select User Role</option>
               <option value="admin" >Admin</option>
               <option value="user">User</option>
                </select>
                <has-error :form="form" field="password"></has-error>
            </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Create </button>
      </div>
      </form>
    </div>
  </div>
     </div>
  </div>
</template>

<script>
    export default {
        data(){
            return {
                users : {},
                form: new Form({
                    name : '',
                    email: '',
                    password: '',
                    type: '',
                    bio: '',
                    photo: ''
                })
            }           
        },
        methods: {
          loadUsers(){
            axios.get("api/user").then(({data}) => (this.users = data.data)); 
          },
          createUser(){
                            this.$Progress.start();

                this.form.post('api/user')
                .then(()=>{
                    Fire.$emit('AfterCreate');
                    $('#addNew').modal('hide')

                    toast({
                        type: 'success',
                        title: 'User Created in successfully'
                        })
                    this.$Progress.finish();

                })
                .catch(()=>{

                })
          }
        },
        created() {
          this.loadUsers();
           Fire.$on('AfterCreate',() => {
               this.loadUsers();
            });
         //   setInterval(() => this.loadUsers(), 3000);
        }
    }
</script>
